<style>
    .settingsColumn {
        width: 100%;
        max-width: 220px;
        padding-right: 10px;
        display: inline-block;
    }
    .settingsColumn h1 {
        font-size: 16px;
        color: #333;
    }

    .avatarPreview {
        max-width: 80px;
        max-height: 80px;
    }

    h1{
        color: #627289;
        font-size: 12pt;
    }

    .panelContainer {
        position: absolute;
        display: inline-block;
        left: 130px;
        right: 0;
        font-size: 0;
    }

    .panel {
        display: inline-block;
        width: 32.5%;
        font-size: 12px;
        vertical-align: top;
        padding-right: 0.5%;
    }

    .panel.col2 {
        width: 65%;
        padding: 0;
    }

    .panel.col2 a {
        display: inline-block;
        width: 49%;
    }
    .panel.wide {
        width: 65%;
    }

    .avatar {
        display: inline-block;
        width: 100px;
    }

    .panel a {
        display: block;
        margin-bottom: 6px;
        padding: 7px;
        color: #333;
        font-size: 110%;
    }
    .panel.wide a {
        display: inline-block;
        width: 49%;
    }

    .panel a:hover small{
        color: #1d9fdc;
    }

    .panel a:hover{
        text-decoration: none;
        background-color: #f5f5f5;
        border-radius: 3px;
    }

    .panel a small{
        display: block;
        margin-top: 3px;
    }


    @media (max-width: 799px) {
        .panel, .panel.wide {
            width: 49%;
        }

        .panel.wide a {
            display: block;
            width: auto;
        }
    }

    @media (max-width: 499px) {
        .panel{
            width: 99.25%;
        }
        .panel.col2{
            width: 99.25%;
        }
        .panelContainer{
            position: static;
            display: block;
        }
        .avatar{
            width: 100%;
        }
    }
</style>
<?

use LabBase\Model\Brand;
use LabBase\Model\Image;
use LabBase\Model\User;

/** @var User $user */
$user = $this->sessionInfo()->getLoggedInUser();

/** @var Image $avatarImage */
// cannot use getUserAvatarImage since we need to know whether the avatar is the default one
$avatarImage = $this->imageLinker()->getImageObject('user-avatar-'.$user->id);
$hasAvatar = true;
if(!$avatarImage) {
    $avatarImage = $this->imageLinker()->getImageObject('system-user-avatar-default');
    $hasAvatar = false;
}


?>

<script>
    function changeAvatar() {
        labImage('Change avatar', function(imageData) {
            if(imageData) {
                var dataStr = imageData.data.split('base64,', 2)[1];
                ajaxSubmit('<?= $this->url('root/userSettings', ['action'=>'changeAvatar']) ?>', {
                    "imageString": dataStr
                }, function (data) {
                    if(data['status'] != 'ok') {
                        console.error(data['status']);
                        alert(data['status']);
                    }else{
                        document.location.reload();
                    }
                });
            }
        }, 400, 400);
    }
</script>

<div id="mainNode" class="node" style="position:relative;height:250px">
    <div class="align-center avatar">
        <img src="<?= $this->imageLinker()->getImageLink($avatarImage) . '?' . $avatarImage->dateCreated ; ?>" class="avatarPreview" />
        <!-- <form enctype="multipart/form-data" method="post" action="<?= $this->url('root/userSettings', ['action'=>'changeAvatar']) ?>">
            <input id="changeAvatarInput" onchange="$(this).parent().submit()" type="file" name="avatarImage" accept="image/*" style="display: none;"/>
        </form>
        <a href="#" onclick="$('#changeAvatarInput').click();$(this).blur()">Change avatar</a><br /> -->
        <a href="#" onclick="changeAvatar()">Change avatar</a>
    </div>
    <div class="panelContainer">
        <div class="panel">
            <h1>My profile</h1>
            <a href="#" onclick="changeUsernameDialog()"><?= $user->fullName; ?><small>Edit display name</small></a>
            <a href="#" onclick="changeEmailDialog()"><?= $user->email; ?><small>Edit email address</small></a>
            <!--<a href="#">Notifications<small>Manage my email notifications</small></a>-->
            <a href="#" onclick="changePasswordDialog()">Password<small>Change my password</small></a>
            <a href="#" onclick="labAlert('This item is currently unavailable. Please contact the support team.')">Close my account<small>Delete all of my data</small></a>
        </div>
        <div class="panel col2">
            <h1>My brands</h1>
            <? foreach($this->brandList as $brand) {
                /** @var Brand $brand */
                ?>
                <a href="<?= $this->url('root/brandFeed', ['brandUrl' => $brand->url]) ?>"><?= $brand->name; ?>
                    <small>Manage brand</small>
                </a>
                <?
            }
            ?>
            <a href="<?= $this->url('root/register'); ?>">+ New brand
                <small>Create new brand</small>
            </a>
        </div>
    </div>
</div>

<script>

    function sendSettingsChangeRequest(dialog, data) {
        $.post("<?= $this->url('root/changeUserSettings'); ?>", data, function(data) {
            if(!data || !data.status) {
                dialog.reset();
                labAlert("An error has ocurred, please try again later or contact our support team.");
            }else if(data.status != 'ok') {
                dialog.reset();
                labAlert(data.status);
            }else{
                if(data && data.redirect) {
                    window.location.href = data.redirect;
                }else{
                    window.location.reload();
                }
            }
        }).error(function() {
            dialog.reset();
            labAlert("An error has ocurred, please try again later or contact our support team.");
        });
    }


    function changeUsernameDialog() {
        var d = new Dialog({}, [
            new DialogComponent(null, "label", "Change your name"),
            new DialogComponent('value', "text", "Your new name"),
            new DialogComponent('password', "password", "Password"),
            new DialogComponent(null, 'row', [
                new DialogComponent(null, "button-single", "Change name", true),
                new DialogComponent(null, "button", "Cancel", false)
            ], 'right')

        ], function(dialog, button, value) {
            console.log(value, dialog);
            if(!value) {
                dialog.close();
                return;
            }
            dialog.disableButtons();
            sendSettingsChangeRequest(d, {
                setting: 'username',
                username: dialog.getComponentById('value').getElement().value,
                password: dialog.getComponentById('password').getElement().value
            });
        });
        d.show();
    }

    function changeEmailDialog() {
        var d = new Dialog({}, [
            new DialogComponent(null, "label", "Change your email address"),
            new DialogComponent('value', "text", "New email address"),
            new DialogComponent('value', "text", "Repeat new email address"),
            new DialogComponent('password', "password", "Password"),
            new DialogComponent(null, 'row', [
                new DialogComponent(null, "button-single", "Change email", true),
                new DialogComponent(null, "button", "Cancel", false)
            ], 'right')

        ], function(dialog, button, value) {
            console.log(value, dialog);
            if(!value) {
                dialog.close();
                return;
            }
            dialog.disableButtons();
            sendSettingsChangeRequest(d, {
                setting: 'email',
                email: dialog.getComponentById('value').getElement().value,
                password: dialog.getComponentById('password').getElement().value
            });

        });
        d.show();
    }

    function changePasswordDialog() {
        var d = new Dialog({}, [
            new DialogComponent(null, "label", "Change your password"),
            new DialogComponent('value1', "password", "New password"),
            new DialogComponent('value2', "password", "Repeat new password"),
            new DialogComponent('password', "password", "Current password"),
            new DialogComponent(null, 'row', [
                new DialogComponent(null, "button-single", "Change password", true),
                new DialogComponent(null, "button", "Cancel", false)
            ], 'right')

        ], function(dialog, button, value) {
            console.log(value, dialog);
            if(!value) {
                dialog.close();
                return;
            }
            var pass = dialog.getComponentById('value1').getElement().value;
            var pass2 = dialog.getComponentById('value2').getElement().value;
            if(pass != pass2) {
                labAlert("Passwords do not match");
                dialog.getComponentById('value1').getElement().value = '';
                dialog.getComponentById('value2').getElement().value = '';
                dialog.getComponentById('value1').getElement().focus();
                return;
            }
            sendSettingsChangeRequest(d, {
                setting: 'password',
                newPassword: pass,
                password: dialog.getComponentById('password').getElement().value
            });
            dialog.disableButtons();
        });
        d.show();
    }

    var resizeFunc = function() {
        if($(".panelContainer").css('position') == "absolute") {
            /*var height = Math.max.apply(null, $(".panelContainer .panel").map(function () {
                return $(this).height();
            }).get());*/
            var height = $('.panelContainer').outerHeight();
            height += 80;
            $("#mainNode").css({'height': height + 'px'});
        }else{
            $("#mainNode").css({'height': 'auto'});
        }

    };

    $(document).ready(function() {
        resizeFunc();
        window.setTimeout(resizeFunc, 200);
    });

    $(window).resize(resizeFunc);
</script>